﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using Microsoft.Windows.Controls.Ribbon;
//using ACVS.Enterprise.Client.Framework;
using System.Windows.Controls;
//using ACVS.Enterprise.Client.Core.Misc;
using System.Diagnostics;
using System.Windows;
using AID = System.Windows.Automation.AutomationProperties;
using System.Windows.Input;


namespace Host.Infrastructure
{
    public class BuildRibbon
    {
        private DataSet _AddinInfo;
        private Ribbon ribbon;
        private bool _builtToolbars;
        private MainWindow parent;


#region framework specific
        private const string TRACING_ADDIN_NAME = "Tracing";
        private const string TRACING_APPSETTINGS_KEY = "Tracing.Enabled";
        private Func<bool> enableTracing;
#endregion
        // for application menu commands:
        private static RoutedUICommand CloseCommand;
        private static RoutedUICommand ShowAboutCommand;
        private static RoutedUICommand ShowHelpCommand;
        private static RoutedUICommand ShowLanguagesCommand;

        // define the ribbon application menu items: 
        RibbonApplicationMenuItem closeItem;
        RibbonApplicationMenuItem aboutItem;
        RibbonApplicationMenuItem languagesItem;
        RibbonButton helpButton;

        /// <summary>
        /// Connects Application menu items to their commands
        /// </summary>
        //private void WireUpCommands()
        //{
        //    // Application menu commands

        //    closeItem.Command = MainWindow.CloseCommand;
        //    CommandBinding closeBinding = new CommandBinding(MainWindow.CloseCommand);
        //    closeBinding.CanExecute += this.closeCommand_CanExecute;
        //    closeBinding.Executed += this.closeCommand_Executed;
        //    this.CommandBindings.Add((CommandBinding)closeBinding);

        //    aboutItem.Command = MainWindow.ShowAboutCommand;
        //    CommandBinding aboutBinding = new CommandBinding(MainWindow.ShowAboutCommand);
        //    aboutBinding.CanExecute += aboutCommand_CanExecute;
        //    aboutBinding.Executed += aboutCommand_Executed;
        //    this.CommandBindings.Add((CommandBinding)aboutBinding);

        //    helpButton.Command = MainWindow.ShowHelpCommand;
        //    CommandBinding helpBinding = new CommandBinding(MainWindow.ShowHelpCommand);
        //    helpBinding.CanExecute += helpCommand_CanExecute;
        //    helpBinding.Executed += helpCommand_Executed;
        //    this.CommandBindings.Add((CommandBinding)helpBinding);

        //    languagesItem.Command = MainWindow.ShowLanguagesCommand;
        //    CommandBinding langBinding = new CommandBinding(MainWindow.ShowLanguagesCommand);
        //    langBinding.CanExecute += languageCommand_CanExecute;
        //    langBinding.Executed += languageCommand_Executed;
        //    this.CommandBindings.Add((CommandBinding)langBinding);
        //}


        /// <summary>
        /// Build the application menu (top left of main window)
        /// </summary>
        public void BuildRibbonApplicationMenu()
        {
            closeItem = new RibbonApplicationMenuItem();
            closeItem.Header = ManagedResources.FindResourceString("ApplicationMenu_CloseLabel");
            closeItem.ToolTipTitle = ManagedResources.FindResourceString("ApplicationMenu_CloseLabelTooltip");
            closeItem.ToolTipDescription = ManagedResources.FindResourceString("ApplicationMenu_CloseLabelTooltipDescription");
            closeItem.ImageSource = ManagedResources.FindResourceImageSource("_10_Client_Menu_Exit_Application_design" /*"ApplicationMenu_CloseImage"*/, GuiStaticLibrary.LargeIconSize);

            aboutItem = new RibbonApplicationMenuItem();
            System.Windows.Automation.AutomationProperties.SetAutomationId(aboutItem, "Core.Host.MainWindow.About");
            aboutItem.Header = ManagedResources.FindResourceString("ApplicationMenu_AboutLabel");
            aboutItem.ToolTipTitle = ManagedResources.FindResourceString("ApplicationMenu_AboutLabelTooltip");
            aboutItem.ToolTipDescription = ManagedResources.FindResourceString("ApplicationMenu_AboutLabelTooltipDescription");
            aboutItem.ImageSource = ManagedResources.FindResourceImageSource("_13_Application_About_design" /*"ApplicationMenu_AboutImage"*/, GuiStaticLibrary.LargeIconSize);

            helpButton = new RibbonButton();
            System.Windows.Automation.AutomationProperties.SetAutomationId(helpButton, "Core.Host.MainWindow.HelpButton");
            helpButton.SmallImageSource = ManagedResources.FindResourceImageSource("_12_Help_design", GuiStaticLibrary.SmallIconSize);
            helpButton.ToolTipTitle = ManagedResources.FindResourceString("ApplicationMenu_HelpLabelTooltip");
            helpButton.ToolTipDescription = ManagedResources.FindResourceString("ApplicationMenu_HelpLabelTooltipDescription");
            ribbon.HelpPaneContent = helpButton;

            languagesItem = new RibbonApplicationMenuItem();
            System.Windows.Automation.AutomationProperties.SetAutomationId(languagesItem, "Core.Host.MainWindow.Languages");
            languagesItem.Header = ManagedResources.FindResourceString("ApplicationMenu_LanguagesLabel");
            languagesItem.ToolTipTitle = ManagedResources.FindResourceString("ApplicationMenu_LanguagesLabelTooltip");
            languagesItem.ToolTipDescription = ManagedResources.FindResourceString("ApplicationMenu_LanguagesLabelTooltipDescription");
            languagesItem.ImageSource = ManagedResources.FindResourceImageSource("_11_Language_Selection_Icon_design" /*"ApplicationMenu_LanguagesIcon"*/, GuiStaticLibrary.LargeIconSize);

            ribbon.ApplicationMenu = new RibbonApplicationMenu();
            ribbon.ApplicationMenu.Name = "RibbonApplicationMenu";
            System.Windows.Automation.AutomationProperties.SetAutomationId(ribbon.ApplicationMenu, "Core.Host.MainWindow.RibbonApplicationMenu");
            ribbon.ApplicationMenu.SmallImageSource = (ImageSource)TryFindResource("AppLogo");

            // Add items to application menu; they will appear in the order
            // they are added
            ribbon.ApplicationMenu.Items.Add(languagesItem);
            ribbon.ApplicationMenu.Items.Add(aboutItem);
            ribbon.ApplicationMenu.Items.Add(closeItem);

            // now connect the UI elements to their commands:
            WireUpCommands();

        }

        /// <summary>
        /// Connects Application menu items to their commands
        /// </summary>
        private void WireUpCommands()
        {
            //// Application menu commands

            //closeItem.Command = parent.CloseCommand;
            //CommandBinding closeBinding = new CommandBinding(parent.CloseCommand);
            //closeBinding.CanExecute += parent.closeCommand_CanExecute;
            //closeBinding.Executed += parent.closeCommand_Executed;
            //this.CommandBindings.Add((CommandBinding)closeBinding);

            //aboutItem.Command = parent.ShowAboutCommand;
            //CommandBinding aboutBinding = new CommandBinding(parent.ShowAboutCommand);
            //aboutBinding.CanExecute += aboutCommand_CanExecute;
            //aboutBinding.Executed += aboutCommand_Executed;
            //this.CommandBindings.Add((CommandBinding)aboutBinding);

            //helpButton.Command = parent.ShowHelpCommand;
            //CommandBinding helpBinding = new CommandBinding(parent.ShowHelpCommand);
            //helpBinding.CanExecute += helpCommand_CanExecute;
            //helpBinding.Executed += helpCommand_Executed;
            //this.CommandBindings.Add((CommandBinding)helpBinding);

            //languagesItem.Command = parent.ShowLanguagesCommand;
            //CommandBinding langBinding = new CommandBinding(parent.ShowLanguagesCommand);
            //langBinding.CanExecute += languageCommand_CanExecute;
            //langBinding.Executed += languageCommand_Executed;
            //this.CommandBindings.Add((CommandBinding)langBinding);
        }


        /// <summary>
        /// Sets the ribbon tab selected to the tab name (should be in current language)
        /// </summary>
        /// <param name="tabName">desired tab label, in current language</param>
        private void SetRibbonTab(string tabName)
        {
            try
            {
                RibbonTab tab = (from RibbonTab t in ribbon.Items where (String)t.Header == tabName select t).SingleOrDefault();
                if (tab != null) ribbon.SelectedItem = tab;
            }
            catch (Exception ex)
            {
                Debug.WriteLine(ex.Message);
            }
        }




        static  BuildRibbon()
        {
            CloseCommand = new RoutedUICommand(
                ManagedResources.FindResourceString("ApplicationMenu_CloseLabel"),
                "Core.Host.MainWindow.Close",
                typeof(MainWindow)
                );
            //TODO put input gesture for close command

            ShowAboutCommand = new RoutedUICommand(
                ManagedResources.FindResourceString("ApplicationMenu_AboutLabel"),
                "Core.Host.MainWindow.About",
                typeof(MainWindow)
                );
            //TODO put input gesture for about command

            ShowHelpCommand = new RoutedUICommand(
                ManagedResources.FindResourceString("ApplicationMenu_HelpLabel"),
                "Core.Host.MainWindow.Help",
                typeof(MainWindow)
                );


            ShowLanguagesCommand = new RoutedUICommand(
                ManagedResources.FindResourceString("ApplicationMenu_LanguagesLabel"),
                "Core.Host.MainWindow.Languages",
                typeof(MainWindow)
                );

        }


        public BuildRibbon(Window parent, DataSet AddinInfo, Ribbon ribbon, Func<bool> enableTracing)
        {
            this.parent = parent;
            this._AddinInfo = AddinInfo;
            this.ribbon = ribbon;
            this.enableTracing = enableTracing;
            BuildRibbonControls();
        }


        private void BuildRibbonControls()
        {
            //DataSet dsAddInInfo = _systemDirector.AllAddInInfo;
            if (ribbon.QuickAccessToolBar == null)
                ribbon.QuickAccessToolBar = new RibbonQuickAccessToolBar();

            ribbon.QuickAccessToolBar.Items.Clear();

            //TODO replace datatable reference
            foreach (DataTable dtAddIn in _AddinInfo.Tables)
            {
                string addinInstance = Utilities.GetArgValue(dtAddIn, "AddInInstance", "");
                if (addinInstance.Length != 0)
                {
                    // Check if the Tracing AddIn should show up in the VEClient
                    if (String.Compare(addinInstance, TRACING_ADDIN_NAME, StringComparison.OrdinalIgnoreCase) == 0)
                    {
                        if (!enableTracing())
                            continue;
                    }

                    BuildToolbar(addinInstance);
                    BuildQuickAccessToolbar(addinInstance);
                }
            }
            // TODO AddCustomizeQuickAccessToolBarButton();

            // now add key tip for each tab, consisting of first letter of each tab header
            // The keytip is the character overlaid next to the tab when the user presses the Alt key
            foreach (Control ctl in ribbon.Items)
            {
                if (ctl is RibbonTab)
                {
                    RibbonTab tab = ctl as RibbonTab;
                    tab.KeyTip = ((string)tab.Header).Substring(0, 1).ToUpper();
                }
            }

            _builtToolbars = true;
        }

        /// <summary>
        /// Helper method that builds the quick acess bar by interrogating the addin.
        /// </summary>
        /// <param name="addinInstance">Addin to interrogate for items to place in the quick access bar</param>
        private void BuildQuickAccessToolbar(string addinInstance)
        {
            // Try to get quick access bar items.
            //TODO remove systemdirector
            //TODO addinInstance convert to real reference
            Host.Infrastructure.Interfaces.IRibbonAddin Qat = null; // _systemDirector.CreateUIElement(addinInstance, "QuickAccessToolbar", null) as IRibbonAddin;
            if (Qat != null)
            {
                AddRibbonQATItems((Ribbon)Qat.RibbonElement);
                BindRibbonCommands(Qat.bindings);
            }
        }

        private void AddRibbonQATItems(Ribbon RibbonElement)
        {
            List<Control> tempList = new List<Control>();
            foreach (Control c in RibbonElement.QuickAccessToolBar.Items)
            {
                tempList.Add(c);
            }
            // detach from addin parent
            RibbonElement.QuickAccessToolBar.Items.Clear();
            // ensure the application ribbon actually has a QAT
            if (ribbon.QuickAccessToolBar == null) ribbon.QuickAccessToolBar = new RibbonQuickAccessToolBar();

            // now transfer addin QAT items to application
            if (tempList.Count > 0)
            {
                foreach (Control c in tempList)
                {
                    // add to application QAT
                    ribbon.QuickAccessToolBar.Items.Add(c);
                }
            }

        }




        /// <summary>
        /// Helper method that builds the main toolbar by interrogating the addin.
        /// </summary>
        /// <param name="addinInstance">Addin to interrogate for items to place in the main toolbar</param>
        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1031:DoNotCatchGeneralExceptionTypes")]
        private void BuildToolbar(string addinInstance)
        {
            try
            {
                // Try to get the items from the addin.
                //TODO replace system director reference
                Host.Infrastructure.Interfaces.IRibbonAddin RibbonAddin = null;// _systemDirector.CreateUIElement(addinInstance, "Toolbar", null) as IRibbonAddin;
                if (RibbonAddin != null)
                {
                    // Addin exposes a ribbon element
                    Ribbon ribbonElement = RibbonAddin.RibbonElement as Ribbon;
                    if (ribbonElement != null)
                    {
                        //AddRibbonElementsToRibbon(ribbonElement);
                        AddRibbonControls(ribbonElement);
                        if (RibbonAddin.bindings != null) BindRibbonCommands(RibbonAddin.bindings);
                    }
                }

            }
            catch (Exception ex)
            {
                Debug.WriteLine(ex.Message);
                //GuiStaticLibrary.DisplayMessageBox(
                MessageBox.Show("Addin " + addinInstance + " Failed to load ribbon controls.\n" + ex.Message, "Error");
            }
        }

        /// <summary>
        /// Bind the commands and gestures from one addin's ribbon controls to the main window
        /// </summary>
        /// <param name="binders"></param>
        private void BindRibbonCommands(List<CommandBinding> binders)
        {
            if (binders == null) throw new ArgumentNullException("binders", "addin did not define bindings for ribbon control elements");
            // bind commands to main window so that bubbling can allow the Alt-<x> gesture to work.
            // if they were bound to the controls, they would only work on the click of the control, but the
            // Alt-<x> gestures would not work.
            foreach (CommandBinding binder in binders)
            {
                parent.CommandBindings.Add((CommandBinding)binder);
            }

        }



        /// <summary>
        /// Add the ribbon controls from the addin to the main window ribbon.
        /// Command bindings are added separately.
        /// </summary>
        /// <param name="RibbonElement">The ribbonElement object from IRibbonAddin</param>
        private void AddRibbonControls(Ribbon RibbonElement)
        {
            List<RibbonTab> tempTabs = new List<RibbonTab>();
            RibbonElement.Items.SortDescriptions.Add(new System.ComponentModel.SortDescription("Name", System.ComponentModel.ListSortDirection.Ascending));
            foreach (Control control in RibbonElement.Items)
            {
                if (control is RibbonTab)
                {
                    tempTabs.Add((RibbonTab)control);
                    AddRibbonAutomationID<RibbonTab>((RibbonTab)control);

                }
                else
                {
                    Debug.WriteLine("Non-ribbon tab control " + control.GetType().ToString());
                    continue;
                }
            }
            // if the addin includes elements for the quick access toolbar, add them
            if (RibbonElement.QuickAccessToolBar != null) AddRibbonQATItems(RibbonElement);
            // if the addin includes elements for the application menu, include them
            if (RibbonElement.ApplicationMenu != null) AddRibbonApplicationMenuItems(RibbonElement);

            // if the addin has RibbonTabs, then detach them from the addin Ribbon, and add them to the 
            // application ribbon
            if (tempTabs.Count > 0)
            {
                RibbonElement.Items.Clear();
                foreach (RibbonTab tab in tempTabs)
                {
                    AddRibbonTabItems(tab);

                }
            }

        }


        private void AddRibbonApplicationMenuItems(Ribbon RibbonElement)
        {
            List<Control> tempList = new List<Control>();
            foreach (Control c in RibbonElement.ApplicationMenu.Items)
            {
                tempList.Add(c);
            }
            // detach from addin parent
            RibbonElement.ApplicationMenu.Items.Clear();
            // ensure the application ribbon actually has an application menu
            if (ribbon.ApplicationMenu == null) ribbon.ApplicationMenu = new RibbonApplicationMenu();
            // now transfer addin menu items to application
            if (tempList.Count > 0)
            {
                foreach (Control c in tempList)
                {
                    // add to application menu
                    AddRibbonAutomationID<Control>(c);
                    ribbon.ApplicationMenu.Items.Add(c);
                }
            }
        }


        /// <summary>
        /// Add ribbon tab items, possibly a complete tab and contained controls, to the main window ribbon.
        /// </summary>
        /// <param name="AddinRibbontab">RibbonTab item</param>
        private void AddRibbonTabItems(RibbonTab AddinRibbontab)
        {
            List<RibbonTab> tempList = new List<RibbonTab>();
            // The top level ribbon control in an addin must be a RibbonTab
            if (AddinRibbontab == null) throw new ApplicationException("Addin did not define a RibbonTab element");

            // rename ribbon tabs to coerce sort order.  Fixes bug 43718
            if (AddinRibbontab.Name == "Home") AddinRibbontab.Name = "AA_Home";
            else if (AddinRibbontab.Name == "Build") AddinRibbontab.Name = "BB_Build";
            else if (AddinRibbontab.Name == "Setup") AddinRibbontab.Name = "CC_Setup";
            else if (AddinRibbontab.Name == "Debug") AddinRibbontab.Name = "ZZ_Debug";   // debug tab always last
            else
            {
                Debug.WriteLine(string.Format("unrecognized tab name  {0}", AddinRibbontab.Name));
            }

            // now see if this RibbonTab is already defined in MainWindow
            ItemCollection rts = ribbon.Items;
            RibbonTab ribbontab = null;
            if (rts != null)
            {
                foreach (Control c in rts)
                {
                    if (c is RibbonTab)
                    {
                        if (c.Name == AddinRibbontab.Name)
                        {
                            // remember the matching tab from the application ribbon
                            ribbontab = (RibbonTab)c;
                            // ribbon tab already exists, check for groups
                            ItemCollection addinGroups = AddinRibbontab.Items;
                            ItemCollection existingGroups = ribbontab.Items;
                            AddRibbonGroups(ribbontab, addinGroups, existingGroups);
                            break;  // we only get one tab candidate at a time from calling method
                        }
                    }
                }
                if (ribbontab == null)
                {
                    // no matching tab, just add the whole addin tab control tree
                    tempList.Add(AddinRibbontab);

                }
            }

            if (tempList.Count > 0)
            {
                // add to the main window ribbon
                foreach (RibbonTab c in tempList)
                {
                    try
                    {
                        AddRibbonAutomationID<RibbonTab>(c);
                        ribbon.Items.Add(c);
                    }
                    catch (ArgumentOutOfRangeException)
                    {
                        // spurious bug in microsoft code
                    }
                    catch (Exception ex)
                    {
                        Debug.WriteLine(ex.Message);
                        ex.Data.Add(c.Name, "Ribbon tab failed to add to ribbon " + c.Name);
                        throw;
                    }
                }
            }
            // ribbon tabs are sorted by Name (not translated header)
            ribbon.Items.SortDescriptions.Add(new System.ComponentModel.SortDescription("Name", System.ComponentModel.ListSortDirection.Ascending));

        }
        /// <summary>
        /// Add Ribbon Groups from the addin to the existing application Tab
        /// </summary>
        /// <param name="ribbontab">exiting application RibbonTab</param>
        /// <param name="addinGroups">collection of groups from the Addin</param>
        /// <param name="existingGroups">existing groups on the ribbontab</param>
        private static void AddRibbonGroups(RibbonTab ribbontab, ItemCollection addinGroups, ItemCollection existingGroups)
        {
            List<RibbonGroup> newGroups = new List<RibbonGroup>();

            foreach (RibbonGroup rbngrp in addinGroups)
            {
                RibbonGroup matchingGroup = null;
                if (existingGroups != null)
                {
                    matchingGroup = (from RibbonGroup g in existingGroups where g.Name == rbngrp.Name select g).FirstOrDefault();
                }

                if (matchingGroup == null)
                {
                    // new group is unique, add it to the list for later adding to the tab
                    // disimplement sorting of buttons in group, conflicts with size arrangements
                    //rbngrp.Items.SortDescriptions.Add(new System.ComponentModel.SortDescription("Name", System.ComponentModel.ListSortDirection.Ascending));
                    AddRibbonAutomationID<RibbonGroup>(rbngrp);
                    newGroups.Add(rbngrp);
                }
                else
                {
                    // group already exists, so add new items to existing matching group
                    // first, copy the child controls to a temp container
                    List<Control> temp = new List<Control>();
                    foreach (Control c in rbngrp.Items)
                    {
                        temp.Add(c);
                    }
                    // remove the association between the addin RibbonGroup and the controls
                    // in the group
                    rbngrp.Items.Clear();
                    // now add the addin's group's controls to the exiting RibbonGroup
                    foreach (Control c in temp)
                    {
                        AddRibbonAutomationID<Control>(c);
                        matchingGroup.Items.Add(c);
                    }
                    // disimplement sorting of buttons in group, conflicts with size arrangements
                    //matchingGroup.Items.SortDescriptions.Add(new System.ComponentModel.SortDescription("Name", System.ComponentModel.ListSortDirection.Ascending));
                }
            } // foreach

            // now, remove groups from the addin tab, and add them to the existing tab
            if (newGroups.Count > 0)
            {
                RibbonTab tab = (RibbonTab)newGroups[0].Parent;
                tab.Items.Clear();
                foreach (RibbonGroup grp in newGroups)
                {
                    ribbontab.Items.Add(grp);
                }
                // sort layout of groups by name, within the tab
                ribbontab.Items.SortDescriptions.Add(new System.ComponentModel.SortDescription("Name", System.ComponentModel.ListSortDirection.Ascending));
            }
        }

        /// <summary>
        /// Add an automationID for a control which does not have one already
        /// </summary>
        /// <typeparam name="R">The type of the control, such as RibbonTab, RibbonMenu</typeparam>
        /// <param name="item">The control itself</param>
        private static void AddRibbonAutomationID<R>(R item)
        {
            DependencyObject d = item as DependencyObject;
            if (d == null) return;

            if (string.IsNullOrEmpty(AID.GetAutomationId(d)))
            {
                // set a default automation ID
                dynamic dy = item;
                Type t = typeof(R);
                string aid = null;
                aid = string.Join(".", new string[] { t.Namespace, t.Name });


                AID.SetAutomationId(d, aid);
            }
        }



    }
}
