﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows;

namespace ACVS.Enterprise.Client.Core.Host
{
    /// <summary>
    /// Interaction logic for App.xaml
    /// </summary>
    public partial class App : Application
    {
        protected override void OnStartup(StartupEventArgs e)
        {
            try
            {
                base.OnStartup(e);

                // Configure Bootstrapper
                HostBootstrapper bootstrapper = new HostBootstrapper();
                bootstrapper.Run();
            }

            catch(System.Reflection.ReflectionTypeLoadException rtlException)
            {
                var loaderMessages = new StringBuilder();   
                loaderMessages.AppendLine("While trying to load modules following loader exceptions were found: ");   
                foreach (var loaderException in rtlException.LoaderExceptions)   
                    loaderMessages.AppendLine(loaderException.Message);   
  
                // this is one of our custom exception types.   
                MessageBox.Show(loaderMessages.ToString());
            }
        }
    }
}
